package com.xperia64.diyedit;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

@SuppressWarnings("serial")
public class MusicPlayer extends JFrame implements ActionListener, ItemListener {
	
	private JButton PlayPause;
	private JButton Stop;
	private JButton Export;
	private boolean playing=false;
	private boolean started=false;
	static ExportMidi e2 = new ExportMidi();
	public MusicPlayer()
	{
	     getContentPane().setLayout(null);
	     setupGUI();
	     setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	void setupGUI()
	{
		PlayPause = new JButton();
		PlayPause.setSize(50,50);
		PlayPause.setLocation(20,20);
		PlayPause.setText("|>");
		PlayPause.addActionListener(this);
		getContentPane().add(PlayPause);
		Stop = new JButton();
		Stop.setSize(50,50);
		Stop.setLocation(80,20);
		Stop.setText("[ ]");
		Stop.addActionListener(this);
		getContentPane().add(Stop);
		Export = new JButton();
		Export.setSize(100,50);
		Export.setLocation(140,20);
		Export.setText("Save midi...");
		Export.addActionListener(this);
		getContentPane().add(Export);
		setLocation(50,50);
		setTitle("Music Player: "+new RecordMetadata().getName());
		setSize(300,120);
		setVisible(true);
		setResizable(false);
}
	public void actionPerformed(ActionEvent e) {  
		if(e.getSource()==PlayPause)
		   {
			if(!e2.paused()&&!e2.playing()&&started)
			{
				started=false;
				playing=false;
			}
			if(!playing&&!started)
			{
				playing=true;
				started=true;
				PlayPause.setText("||");
				new PlayThread().start();
				
			}else if(!playing&&started)
			{
				playing = true;
				PlayPause.setText("||");
				e2.PlayPause();
		   	}else if(playing){
				playing=false;
				PlayPause.setText("|>");
				e2.PlayPause();
			}
			  
		   }
		if(e.getSource()==Stop)
		{
			if(!e2.paused()&&!e2.playing()&&started)
			{
				started=false;
				playing=false;
			}
			if(started)
			{
			e2.Stop();
			}
			this.setVisible(false);
		}
		if(e.getSource()==Export)
		{
			JFileChooser fc = new JFileChooser();
			fc.setFileFilter(new MidiFilter());
			
			if(fc.showSaveDialog(this)==JFileChooser.APPROVE_OPTION)
			{
				if(!e2.paused()&&!e2.playing()&&started)
				{
					started=false;
					playing=false;
				}
				if(started)
				{
				e2.Stop();
				}
				e2.export(fc.getSelectedFile().getAbsolutePath(), false);
				this.setVisible(false);
			}
			
		}
	}
    
 
    public void itemStateChanged(ItemEvent e)  {
 
        @SuppressWarnings("unused")
		Object source = e.getItemSelectable();
    }
    
}
	class PlayThread extends Thread
	{
		public void run()
		{
			MusicPlayer.e2.export("", true);
		}
	}
